#ifndef _STEREO_H
#define _STEREO_H
#include "init.h"
#include <math.h>

#define	PI		3.1415926535897932384626433832795f
#define PI180	0.0174532925199432957692369076848861f	// pi / 180

#ifndef screen_x
#define screen_x 800
#endif

#ifndef screen_y
#define screen_y 600
#endif

extern int sirka,vyska;		// z init.cpp - aktualna sirka a vyska okna
extern	float	fps;		// kvoli funkcii Update
enum glassestype_ { REDBLUE, REDGREEN, REDCYAN, BLUERED, GREENRED, CYANRED};

struct Stereo {
	float focallength;		// Focal Length along vd	- vzdialenost na ktoru sa zaostruje
	float fovy;				// The field of view angle, in degrees, in the y-direction.
	float eyesep;			// Eye separation			- vzdialenost oci
	float near_;			// blizka orezavacia rovina
	float far_;				// vzdialena orezavacia rovina
	
	float posuv;			// posunutie obrazkov
	float sep;				// eye separation - pomocna premenna pre nastavovanie pomocu klavesnice
	bool  glasses;			// okuliare - alebo bez okuliarov
	bool  auto_focus;		// automaticke zaostrovanie
	glassestype_ glassestype;	// typ farebnuch okuliarov
public:
	void LeftEye(void);		// nastavenie kreslenie pre lave oko
	void RightEye(void);	// nastavenie kreslenie pre prave oko
	void Center(void);		// nasatvenie normalneho vykreslovania
	Stereo(bool glasses_);	// konstruktor
	void Set(float vzdialenost);	// zaostry na vzdialenost
	void Update(float vzdialenost = 0);		// nastavuje parametre podla klaves
};


#endif