#include "fxz_plochy.h"

Fxz_plochy::Fxz_plochy(void)
{
	Vypln_polia_vrcholov( -box_sirka/2, box_sirka, -box_dlzka/2, box_dlzka);
	hran_l = new int[delenie_z];
	hran_r = new int[delenie_z];
	pas    = new int[delenie_z];

	list = glGenLists(1);
	glNewList(list,GL_COMPILE);
	Kresli_();
	glEndList();
}

Fxz_plochy::~Fxz_plochy(void)
{
	delete [] hran_l;
	delete [] hran_r;
	delete [] pas;

	glDeleteLists(list,1);
	
	glDisableClientState(GL_VERTEX_ARRAY );
	glDisableClientState(GL_TEXTURE_COORD_ARRAY );
	if(vertex != NULL)delete [] vertex;
	if(texcoord != NULL)delete [] texcoord;
	if(textura != NULL)delete [] textura;

	vertex = NULL;
}


void Fxz_plochy::Vypln_polia_vrcholov(float x, float dx, float z, float dz)
{
	int x1,z1;
	int	i=0,t=0;
	float ddx,ddz;
	float x2,z2;
	
	// jeden pas ma 2*delenie_x trojuholnikov, na kreslenie potrebujeme 2 body naviac, kazdy bod ma 3 suradnice -> 3*(2*delenie_x+2)
	vertex = new float[ 6*(delenie_x+1)*delenie_z];	
	texcoord = new float[ 4*(delenie_x+1)*delenie_z];
	textura = new unsigned int[delenie_x*delenie_z];

	if(vertex == NULL || texcoord== NULL || textura==NULL) {MessageBox(NULL,"Chyba","Malo pamete",MB_OK | MB_ICONERROR); keys[VK_ESCAPE]=1;return;}

	for(int j=0; j < delenie_z; j++)
		for(int i=0; i < delenie_x; i++)
			textura[ j*delenie_x + i] = map->Textura(i,j);

	ddx = dx / (float)delenie_x;
	ddz = dz / (float)delenie_z;

	for(z1 = 0; z1 < delenie_z ; z1++)
	{
		x2 = x;					// zacinam s najnisou suradnicou x
		z2 = z + z1 * ddz;		// a najnizsou suradnicou z - najdalej od nas
		vertex[i++] = x2;				//  |	0	2	4	6	8	10	.
		vertex[i++] = map->Fxz(x2,z2);	// z|	x -->
		vertex[i++] = z2;				//  v	1	3	5	7	9	11	.
		texcoord[t++] = 0;					
		texcoord[t++] = (float)(delenie_z-z1)/(float)delenie_z;

		vertex[i++] = x2;
		vertex[i++] = map->Fxz(x2,z2+ddz);
		vertex[i++] = z2+ddz;
		texcoord[t++] = 0;
		texcoord[t++] = (float)(delenie_z-z1-1)/(float)delenie_z;
		//glvertex3f( x2 , Fxz(x2,z2-ddz), z2-ddz);
		//glvertex3f( x2 , Fxz(x2,z2), z2);
		for(x1 = 1; x1 < delenie_x+1 ; x1++)
		{
			x2 = x + x1 * ddx;

			vertex[i++] = x2;
			vertex[i++] = map->Fxz(x2,z2);
			vertex[i++] = z2;
			texcoord[t++] = (float)x1/(float)delenie_x;
			texcoord[t++] = (float)(delenie_z-z1)/(float)delenie_z;

			vertex[i++] = x2;
			vertex[i++] = map->Fxz(x2,z2+ddz);
			vertex[i++] = z2+ddz;
			texcoord[t++] = (float)x1/(float)delenie_x;
			texcoord[t++] = (float)(delenie_z-z1-1)/(float)delenie_z;

			//glvertex3f( x2 , Fxz(x2,z2-ddz), z2-ddz);
			//glvertex3f( x2 , Fxz(x2,z2), z2);
		}
	}
	glEnableClientState(GL_VERTEX_ARRAY );
	glVertexPointer(3, GL_FLOAT, 0, vertex);
	glEnableClientState(GL_TEXTURE_COORD_ARRAY);
	glTexCoordPointer(2, GL_FLOAT, 0, texcoord);
}

void Fxz_plochy::Kresli_glBegin(void)
{
	int max_x;
	triangles=0;

	max_x = 2*(delenie_x+1);
	for(unsigned int textur=0; textur<POCET_TEXTUR; textur++)
	{
		glBindTexture(GL_TEXTURE_2D, texture[textur]);
		for(int j = 0; j < delenie_z; j++)
		{
			if(pas[j])
			{
				
				for(int i = hran_l[j]; i < hran_r[j]; i+=2)
				{
					if(textura[(j*delenie_x+i/2)]==textur)
					{
						glBegin(GL_TRIANGLE_STRIP);
						for(int i_ = i; (i_ < hran_r[j]-2)&&(textura[(j*delenie_x+i/2)]==textur); i_++)
						{
							//glTexCoord2fv(&texcoord[2*(j*max_x+i_)]);
							switch(i_%4)
							{
							case 0:glTexCoord2f(0,1);break;
							case 1:glTexCoord2f(0,0);break;
							case 2:glTexCoord2f(1,1);break;
							case 3:glTexCoord2f(1,0);break;
							}
							glVertex3fv(&vertex[3*(j*max_x+i_)]);
							triangles++;
							i++;
						}
						//glTexCoord2fv(&texcoord[2*(j*max_x+i)]);
						switch(i%4)
							{
							case 0:glTexCoord2f(0,1);break;
							case 1:glTexCoord2f(0,0);break;
							case 2:glTexCoord2f(1,1);break;
							case 3:glTexCoord2f(1,0);break;
							}
						glVertex3fv(&vertex[3*(j*max_x+i)]);
						//glTexCoord2fv(&texcoord[2*(j*max_x+i+1)]);
						switch((i+1)%4)
							{
							case 0:glTexCoord2f(0,1);break;
							case 1:glTexCoord2f(0,0);break;
							case 2:glTexCoord2f(1,1);break;
							case 3:glTexCoord2f(1,0);break;
							}
						glVertex3fv(&vertex[3*(j*max_x+i+1)]);
						glEnd();
					}
				}
			}
		}
	}
}


void Fxz_plochy::Kresli_glBegin_(void)
{
	int max_x;
	triangles=0;

	max_x = 2*(delenie_x+1);
	for(int j = 0; j < delenie_z; j++)
	{
		if(pas[j])
		{
			glBegin(GL_TRIANGLE_STRIP);
			for(int i = hran_l[j]; i < hran_r[j]; i++) 
			{
				glTexCoord2fv(&texcoord[2*(j*max_x+i)]);
				glVertex3fv(&vertex[3*(j*max_x+i)]);
				triangles++;
			}
			triangles--;triangles--;
			glEnd();
		}
	}
}

void Fxz_plochy::Kresli_display()
{
	triangles=delenie_x*delenie_z*2;
	glCallList(list);
}

void Fxz_plochy::Kresli_ArrayElement()
{
	int max_x;
	triangles=0;

	max_x = 2*(delenie_x+1);
	for(int j = 0; j < delenie_z; j++)
	{
		if(pas[j])
		{
			glBegin(GL_TRIANGLE_STRIP);
			for(int i = hran_l[j]; i < hran_r[j]; i++) 
			{
				glArrayElement(j*max_x+i);
				triangles++;
			}
			triangles--;triangles--;
			glEnd();
		}
	}
}

/*
void Fxz_plochy::Kresli_ArrayElement()
{
	int max_x;

	max_x = 2*(delenie_x+1);
	for(int j = 0; j < delenie_z; j++)
	{
		glBegin(GL_TRIANGLE_STRIP);
		for(int i = 0; i < max_x; i++) glArrayElement(j*max_x+i);
		glEnd();
	}
}*/

//enum hrana_{ina,horna,dolna,lava,prava};

void Fxz_plochy::Vyp_hranice(XYZ vp, XYZ vd)
{
	int i,ix,iz,ix_,iz_;
	hrana_ hrana=ina;

	XZ	k,k_pom;
	double uhol_kamery_vyp;
	float	p,r;				// smernica priamky, parameter
	
	for(i=0; i< delenie_z; i++)hran_l[i]=0;
	for(i=0; i< delenie_z; i++)hran_r[i]= 2*delenie_x+2;
	for(i=0; i< delenie_z; i++)pas[i]=0;

	if(keys['S'] && keys[VK_SHIFT])
	{
		vp.x += 5*vd.x;
		vp.z += 5*vd.z;
	}
	else if(!keys['S'])
	{
		vp.x -= (float)posunutie_orezavacich_rovin_k_nam*box_sirka*vd.x;
		vp.z -= (float)posunutie_orezavacich_rovin_k_nam*box_dlzka*vd.z;
	}

	ix = (int) floor(  (vp.x + 0.5*box_sirka)*(float)delenie_x /box_sirka );	// index v ktorom stvorci je vp
	iz = (int) floor(  (vp.z + 0.5*box_dlzka)*(float)delenie_z /box_dlzka );	//
	if(iz >= delenie_z || iz<0 || ix >= delenie_x || ix<0)	// ak sme mimo boxu zobrazi sa vsetko
	{
		for(i=0; i< delenie_z; i++)pas[i]=1;
		return;
	}

	if(sqrt(vd.x*vd.x+vd.z*vd.z)>1e-2)  // ak nie sme otoceny kolmo dole tak pocita orezevacie roviny
	{	//  A z    A
		//  |     / vyska vektora -tan(uhol_kamery)
		//  |   /  uhol_kamery_vyp = atan( vyska / dlzka )
		//  | /
		//  +------|-----> x
		//      dlzka vektora vd premietnuteho na xz - sqrt(vd.x*vd.x+vd.z*vd.z)
		uhol_kamery_vyp = (2.0/PI180)*atan(tan(0.5*PI180*uhol_kamery)/sqrt(vd.x*vd.x+vd.z*vd.z) ); }
	else return;			// ak sme otoceny kolmo dole tak nepocitaj orezavacie roviny
	
	ix_ = ix;
	iz_ = iz;

	k.x = vd.x * (float) cos( -0.5*PI180*uhol_kamery_vyp ) - vd.z * (float) sin( -0.5*PI180*uhol_kamery_vyp );
	k.z = vd.x * (float) sin( -0.5*PI180*uhol_kamery_vyp ) + vd.z * (float) cos( -0.5*PI180*uhol_kamery_vyp );
	if(k.z<1e-6 && k.z>-1e-6)k.z = (float)1.0e-6;
	if(k.x<1e-6 && k.x>-1e-6)k.x = (float)1.0e-6;
	k_pom.x = vd.x * (float) cos( 0.5*PI180*uhol_kamery_vyp ) - vd.z * (float) sin( 0.5*PI180*uhol_kamery_vyp );
	k_pom.z = vd.x * (float) sin( 0.5*PI180*uhol_kamery_vyp ) + vd.z * (float) cos( 0.5*PI180*uhol_kamery_vyp );
//	if(k.z<1e-6 && k.z>-1e-6){MessageBox(NULL,"","k.z = 0",MB_OK);return;}
	if	   (k.z>0 && fabs(k.z)>=fabs(k.x) )hrana = dolna;
	else if(k.z<0 && fabs(k.z)>=fabs(k.x) )hrana = horna;
	else if(k.x>0 && fabs(k.x)>=fabs(k.z) )hrana = prava;
	else if(k.x<0 && fabs(k.x)>=fabs(k.z) )hrana = lava;

	// priamka hlavna	x = k.x * p + vp.x
	//					z = k.z * p + vp.z
	// horna hranica stvorca x = r*box_sirka/delenie_x + ( (float)(ix  )*box_sirka/(float)delenie_x ) - 0.5*box_sirka;
	//						 z = (float)(iz  )*box_dlzka/(float)delenie_z - 0.5*box_dlzka;
	// dolna hranica stvorca z = (float)(iz+1)*box_dlzka/(float)delenie_z - 0.5*box_dlzka;
	// lava strana stvorca	x = ( (float)(ix  )*box_sirka/(float)delenie_x ) - 0.5*box_sirka;
	//						z = r*box_dlzka/delenie_z + ( (float)(iz  )*box_dlzka/(float)delenie_z )-0.5*box_dlzka;
	// prava strana stvorca x = ( (float)(ix+1)*box_sirka/(float)delenie_x ) - 0.5*box_sirka;

	// riesenie konfliktu = ak r < 0 || r > 1 bod nepatri stvorcu
	if(k.z<0)		// lava orezavacia rovina je hore
	{
		if(k.x>0)	// vpravo
		{
			while(  (iz < delenie_z) && (iz >= 0) )
			{
				hran_l[iz]=2*ix; pas[iz]=1;
		// prava strana stvorca x = ( (float)(ix+1)*box_sirka/(float)delenie_x ) - 0.5*box_sirka;
				if(hrana!=lava)
				{
					p = ( (float)(ix+1)*box_sirka/(float)delenie_x - 0.5f*box_sirka-vp.x)/k.x;
					r = (k.z*p+vp.z - (float)(iz)*box_dlzka/(float)delenie_z +0.5f*box_dlzka)*delenie_z/box_dlzka;
					if(r>=0 && r<=1) 
					{
						if(ix<(delenie_x-1) )ix++;
						else iz = -2;
						continue;
					}
				}
		// horna strana stvorca
		//	k.x * p + vp.x = r*box_sirka/delenie_x + ( (float)(ix  )*box_sirka/(float)delenie_x ) - 0.5*box_sirka;
		//	k.z * p + vp.z = (float)(iz  )*box_dlzka/(float)delenie_z - 0.5*box_dlzka;
				if(hrana!=dolna)
				{
					p = ( (float)(iz  )*box_dlzka/(float)delenie_z - 0.5f*box_dlzka-vp.z )/k.z;
					r = (k.x*p+vp.x - ( (float)(ix  )*box_sirka/(float)delenie_x ) + 0.5f*box_sirka)*delenie_x/box_sirka;
					if(r>=0 && r<=1)
					{
						iz--;
						continue;
					}
				}
				iz--;
			//	MessageBox(NULL,"Chyba","lava, hore, vpravo ",MB_OK); 
				continue;
				keys[VK_ESCAPE]=1;return;
			}
		}
		else	// vlavo
		{
			while(  (iz < delenie_z) && (iz >= 0) )
			{
				hran_l[iz]=2*ix; pas[iz]=1;
		// lava strana stvorca	x = ( (float)(ix  )*box_sirka/(float)delenie_x ) - 0.5*box_sirka;
		//						z = r*box_dlzka/delenie_z + ( (float)(iz+1)*box_dlzka/(float)delenie_z )-0.5*box_dlzka;
				if(hrana!=prava)
				{
					p = ( (float)(ix)*box_sirka/(float)delenie_x - 0.5f*box_sirka-vp.x)/k.x;
					r = (k.z*p+vp.z - (float)(iz)*box_dlzka/(float)delenie_z +0.5f*box_dlzka)*delenie_z/box_dlzka;
					if(r>=0 && r<=1) 
					{
						if(ix>0)ix--;
						else
						{
							if(k_pom.x>0) for(;iz>=0;iz--){hran_l[iz]=2*ix; pas[iz]=1;}
							else iz = -2;
						}
						continue;
					}
				}
		// horna strana stvorca
		//	k.x * p + vp.x = r*box_sirka/delenie_x + ( (float)(ix  )*box_sirka/(float)delenie_x ) - 0.5*box_sirka;
		//	k.z * p + vp.z = (float)(iz  )*box_dlzka/(float)delenie_z - 0.5*box_dlzka;
				if(hrana!=dolna)
				{
					p = ( (float)(iz  )*box_dlzka/(float)delenie_z - 0.5f*box_dlzka-vp.z )/k.z;
					r = (k.x*p+vp.x - ( (float)(ix  )*box_sirka/(float)delenie_x ) + 0.5f*box_sirka)*delenie_x/box_sirka;
					if(r>=0 && r<=1)
					{
						iz--;
						continue;
					}
				}
				iz--;
			//	MessageBox(NULL,"Chyba","lava, hore, vlavo ",MB_OK);
				continue;
				keys[VK_ESCAPE]=1;return;
			}
		}
	}
	else   // lava orezavacia rovina je dole
	{
		if(k.x<0)	//  vlavo
		{
			while(  (iz < delenie_z) && (iz >= 0) )
			{
				hran_r[iz]=2*ix+2; pas[iz]=1;
		// dolna hranica stvorca z = (float)(iz+1)*box_dlzka/(float)delenie_z - 0.5*box_dlzka;
				if(hrana!=horna)
				{
					p = ( (float)(iz+1)*box_dlzka/(float)delenie_z - 0.5f*box_dlzka-vp.z )/k.z;
					r = (k.x*p+vp.x - ( (float)(ix  )*box_sirka/(float)delenie_x ) + 0.5f*box_sirka)*delenie_x/box_sirka;
					if(r>=0 && r<=1) 
					{
						iz++; 
						continue;
					}
				}
		// lava strana stvorca	x = ( (float)(ix  )*box_sirka/(float)delenie_x ) - 0.5*box_sirka;
		//						z = r*box_dlzka/delenie_z + ( (float)(iz+1)*box_dlzka/(float)delenie_z )-0.5*box_dlzka;
				if(hrana!=prava)
				{
					p = ( (float)(ix)*box_sirka/(float)delenie_x - 0.5f*box_sirka-vp.x)/k.x;
					r = (k.z*p+vp.z - (float)(iz)*box_dlzka/(float)delenie_z +0.5f*box_dlzka)*delenie_z/box_dlzka;
					if(r>=0 && r<=1) 
					{
						if(ix>0)ix--;
						else iz = -2;
						continue;
					}
				}
				{if(ix>0)ix--;else iz = -2;}
			//	MessageBox(NULL,"Chyba","lava, dole, vlavo ",MB_OK);
				continue;
				keys[VK_ESCAPE]=1;return;
			}
		}
		else		// lava orezavacia rovina je vpravo
		{
			while(  (iz < delenie_z) && (iz >= 0) )
			{
				hran_r[iz]=2*ix+2; pas[iz]=1;
		// dolna hranica stvorca z = (float)(iz+1)*box_dlzka/(float)delenie_z - 0.5*box_dlzka;
				if(hrana!=horna)
				{
					p = ( (float)(iz+1)*box_dlzka/(float)delenie_z - 0.5f*box_dlzka-vp.z )/k.z;
					r = (k.x*p+vp.x - ( (float)(ix  )*box_sirka/(float)delenie_x ) + 0.5f*box_sirka)*delenie_x/box_sirka;
					if(r>=0 && r<=1) 
					{
						iz++; 
						continue;
					}
				}
		// prava strana stvorca x = ( (float)(ix+1)*box_sirka/(float)delenie_x ) - 0.5*box_sirka;
				if(hrana!=lava)
				{
					p = ( (float)(ix+1)*box_sirka/(float)delenie_x - 0.5f*box_sirka-vp.x)/k.x;
					r = (k.z*p+vp.z - (float)(iz)*box_dlzka/(float)delenie_z +0.5f*box_dlzka)*delenie_z/box_dlzka;
					if(r>=0 && r<=1) 
					{
						if(ix<(delenie_x-1) )ix++;
						else iz = -2;
						continue;
					}
				}
				{if(ix<(delenie_x-1) )ix++;else iz = -2;}
			//	MessageBox(NULL,"Chyba","lava, dole, vpravo ",MB_OK);
				continue;
				 keys[VK_ESCAPE]=1;return;
			}
		}
	}

	ix = ix_;
	iz = iz_;

//	k.x = vd.x * (float) cos( 0.5*PI180*uhol_kamery_vyp ) - vd.z * (float) sin( 0.5*PI180*uhol_kamery_vyp );
//	k.z = vd.x * (float) sin( 0.5*PI180*uhol_kamery_vyp ) + vd.z * (float) cos( 0.5*PI180*uhol_kamery_vyp );
	k.x = k_pom.x;
	k.z = k_pom.z;
	if(k.z<1e-6 && k.z>-1e-6)k.z = (float)1.0e-6;
	if(k.x<1e-6 && k.x>-1e-6)k.x = (float)1.0e-6;
	//if(k.z<1e-6 && k.z>-1e-6){MessageBox(NULL,"","k.z = 0",MB_OK);return;}

	hrana = ina;
	if	   (k.z>0 && (fabs(k.z)>=fabs(k.x)) )hrana = dolna;
	else if(k.z<0 && (fabs(k.z)>=fabs(k.x)) )hrana = horna;
	else if(k.x>0 && (fabs(k.x)>=fabs(k.z)) )hrana = prava;
	else if(k.x<0 && (fabs(k.x)>=fabs(k.z)) )hrana = lava;

	if(k.z<0)	// prava hrana je hore
	{
		if(k.x>0)		// vpravo
		{
			while(  (iz < delenie_z) && (iz >= 0) )
			{
				hran_r[iz]=2*ix+2; pas[iz]=1;
		// prava strana stvorca x = ( (float)(ix+1)*box_sirka/(float)delenie_x ) - 0.5*box_sirka;
				if(hrana!=lava)
				{
					p = ( (float)(ix+1)*box_sirka/(float)delenie_x - 0.5f*box_sirka-vp.x)/k.x;
					r = (k.z*p+vp.z - (float)(iz)*box_dlzka/(float)delenie_z +0.5f*box_dlzka)*delenie_z/box_dlzka;
					if(r>=0 && r<=1) 
					{
						if(ix<(delenie_x-1) )ix++;
						else iz = -2;
						continue;
					}
				}

		// horna strana stvorca
		//	k.x * p + vp.x = r*box_sirka/delenie_x + ( (float)(ix  )*box_sirka/(float)delenie_x ) - 0.5*box_sirka;
		//	k.z * p + vp.z = (float)(iz  )*box_dlzka/(float)delenie_z - 0.5*box_dlzka;
				if(hrana!=dolna)
				{
					p = ( (float)(iz  )*box_dlzka/(float)delenie_z - 0.5f*box_dlzka-vp.z )/k.z;
					r = (k.x*p+vp.x - ( (float)(ix  )*box_sirka/(float)delenie_x ) + 0.5f*box_sirka)*delenie_x/box_sirka;
					if(r>=0 && r<=1)
					{
						iz--; 
						continue;
					}
				}
				iz--;
			//	MessageBox(NULL,"Chyba","prava, hore, vpravo ",MB_OK);
				continue;
				 keys[VK_ESCAPE]=1;return;
			}
		}
		else	// lavo
		{
			while(  (iz < delenie_z) && (iz >= 0) )
			{
				hran_r[iz]=2*ix+2; pas[iz]=1;
		// lava strana stvorca	x = ( (float)(ix  )*box_sirka/(float)delenie_x ) - 0.5*box_sirka;
		//						z = r*box_dlzka/delenie_z + ( (float)(iz+1)*box_dlzka/(float)delenie_z )-0.5*box_dlzka;
				if(hrana!=prava)
				{
					p = ( (float)(ix)*box_sirka/(float)delenie_x - 0.5f*box_sirka-vp.x)/k.x;
					r = (k.z*p+vp.z - (float)(iz)*box_dlzka/(float)delenie_z +0.5f*box_dlzka)*delenie_z/box_dlzka;
					if(r>=0 && r<=1) 
					{
						if(ix>0)ix--;
						else iz = -2;
						continue;
					}
				}
		// horna strana stvorca
		//	k.x * p + vp.x = r*box_sirka/delenie_x + ( (float)(ix  )*box_sirka/(float)delenie_x ) - 0.5*box_sirka;
		//	k.z * p + vp.z = (float)(iz  )*box_dlzka/(float)delenie_z - 0.5*box_dlzka;
				if(hrana!=dolna)
				{
					p = ( (float)(iz  )*box_dlzka/(float)delenie_z - 0.5f*box_dlzka-vp.z )/k.z;
					r = (k.x*p+vp.x - ( (float)(ix  )*box_sirka/(float)delenie_x ) + 0.5f*box_sirka)*delenie_x/box_sirka;
					if(r>=0 && r<=1)
					{
						iz--;
						continue;
					}
				}
				iz--;
			//	MessageBox(NULL,"Chyba","prava, hore, vlavo ",MB_OK);
				continue;
				 keys[VK_ESCAPE]=1;return;
			}
		}
	}
	else  // prava hrana je dole
	{
		if(k.x>0)  // prava hrana je vpravo
		{
			while(  (iz < delenie_z) && (iz >= 0) )
			{
				hran_l[iz]=2*ix; pas[iz]=1;
		// prava strana stvorca x = ( (float)(ix+1)*box_sirka/(float)delenie_x ) - 0.5*box_sirka;
				if(hrana!=lava)
				{
					p = ( (float)(ix+1)*box_sirka/(float)delenie_x - 0.5f*box_sirka-vp.x)/k.x;
					r = (k.z*p+vp.z - (float)(iz)*box_dlzka/(float)delenie_z +0.5f*box_dlzka)*delenie_z/box_dlzka;
					if(r>=0 && r<=1) 
					{
						if(ix<(delenie_x-1) )ix++;
						else iz = -2;
						continue;
					}
				}
		// dolna hranica stvorca z = (float)(iz+1)*box_dlzka/(float)delenie_z - 0.5*box_dlzka;
				if(hrana!=horna)
				{
					p = ( (float)(iz+1)*box_dlzka/(float)delenie_z - 0.5f*box_dlzka-vp.z )/k.z;
					r = (k.x*p+vp.x - ( (float)(ix  )*box_sirka/(float)delenie_x ) + 0.5f*box_sirka)*delenie_x/box_sirka;
					if(r>=0 && r<=1 ) 
					{
						iz++; 
						continue;
					}
				}
				if(ix<(delenie_x-1) )ix++;else iz = -2;
				continue;
				 keys[VK_ESCAPE]=1;return;
			}
		}
		else  //  vlavo
		{
			while(  (iz < delenie_z) && (iz >= 0) )
			{
				hran_l[iz]=2*ix; pas[iz]=1;
		// lava strana stvorca	x = ( (float)(ix  )*box_sirka/(float)delenie_x ) - 0.5*box_sirka;
		//						z = r*box_dlzka/delenie_z + ( (float)(iz+1)*box_dlzka/(float)delenie_z )-0.5*box_dlzka;
				if(hrana!=prava)
				{
					p = ( (float)(ix)*box_sirka/(float)delenie_x - 0.5f*box_sirka-vp.x)/k.x;
					r = (k.z*p+vp.z - (float)(iz)*box_dlzka/(float)delenie_z +0.5f*box_dlzka)*delenie_z/box_dlzka;
					if(r>=0 && r<=1) 
					{
						if(ix>0)ix--;
						else iz = -2;
						continue;
					}
				}
		// dolna hranica stvorca z = (float)(iz+1)*box_dlzka/(float)delenie_z - 0.5*box_dlzka;
				if(hrana!=horna)
				{
					p = ( (float)(iz+1)*box_dlzka/(float)delenie_z - 0.5f*box_dlzka-vp.z )/k.z;
					r = (k.x*p+vp.x - ( (float)(ix  )*box_sirka/(float)delenie_x ) + 0.5f*box_sirka)*delenie_x/box_sirka;
					if(r>=0 && r<=1) 
					{
						iz++; 
						continue;
					}
				}
				if(ix>0)ix--;else iz = -2;
			//	MessageBox(NULL,"Chyba","prava, dole, vlavo ",MB_OK);
				continue;
				 keys[VK_ESCAPE]=1;return;
			}
		}
	}
}



void Fxz_plochy::Kresli_(void)
{
	int max_x;

	max_x = 2*(delenie_x+1);
	for(int j = 0; j < delenie_z; j++)
	{
		glBegin(GL_TRIANGLE_STRIP);
		for(int i = 0; i < max_x; i++) 
		{
			glTexCoord2fv(&texcoord[2*(j*max_x+i)]);
			glVertex3fv(&vertex[3*(j*max_x+i)]);
		}
		glEnd();
	}
}

void Fxz_plochy::Orezanie_na_vzdialenost(float orezavacia_vzdialenost, XYZ vp, XYZ vd)
{
	int i,ix,iz,r;

	if(keys['S'] && keys[VK_SHIFT])
	{
		vp.x += 5*vd.x;
		vp.z += 5*vd.z;
	}

	orezavacia_vzdialenost = (float)cos(asin(fabs(vd.y))) * orezavacia_vzdialenost;
	r = (int)ceil(orezavacia_vzdialenost / ((float)box_sirka/(float)delenie_x) );

	ix = (int) floor(  (vp.x + 0.5*box_sirka)*(float)delenie_x /box_sirka );	// index v ktorom stvorci je vp
	iz = (int) floor(  (vp.z + 0.5*box_dlzka)*(float)delenie_z /box_dlzka );	//
	
	if(iz >= delenie_z || iz<0 || ix >= delenie_x || ix<0)return;

	for(i = 0; i<delenie_z; i++)
	{
		if(pas[i])
		{
			if( (i >= iz - r) && (i <= iz + r) )
			{
				if(hran_l[i] < 2*(-(int)sqrt(r*r-(i-iz)*(i-iz))+ix) ) hran_l[i] = 2*(-(int)sqrt(r*r-(i-iz)*(i-iz))+ix);
			}
			else pas[i] = 0;
		}
	}

	for(i = 0; i<delenie_z; i++)
	{
		if(pas[i])
		{
			if( (i >= iz - r) && (i <= iz + r) )
			{
				if(hran_r[i] > 2*((int)sqrt(r*r-(i-iz)*(i-iz))+ix)+2 ) hran_r[i] = 2*((int)sqrt(r*r-(i-iz)*(i-iz))+ix)+2;
			}
			else pas[i] = 0;
		}
	}


	// kruh
	//r = sin(asin(vd.z))*tan(0.5*uhol_kamery_vyp*PI180)*vp.y;

	orezavacia_vzdialenost = (float)fabs(vd.y)*(float)tan(0.5*uhol_kamery*PI180)*(float)fabs(vp.y);
	r = (int)ceil(orezavacia_vzdialenost / (box_sirka/(float)delenie_x) );

	for(i = iz-r; i<=iz+r; i++)
	{
		if(i < 0 || i >= delenie_z) continue;
		if(pas[i]==0)
		{
			pas[i] = 1;
			hran_l[i] = 2*delenie_x+2;
			hran_r[i] = 0;
		}
		if(hran_l[i] > 2*(-(int)sqrt(r*r-(i-iz)*(i-iz))+ix) ) hran_l[i] = 2*(-(int)sqrt(r*r-(i-iz)*(i-iz))+ix);
		if(hran_l[i] < 0) hran_l[i] = 0;
		if(hran_r[i] < 2*((int)sqrt(r*r-(i-iz)*(i-iz))+ix)+2 ) hran_r[i] = 2*((int)sqrt(r*r-(i-iz)*(i-iz))+ix)+2;
		if(hran_r[i] > 2*delenie_x+2)hran_r[i]= 2*delenie_x+2;	// Treba ja toto ?
	}

}
