// height_map.cpp: implementation of the height_map class.
//
//////////////////////////////////////////////////////////////////////

#include "height_map.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////
#define obrazok_x 256 // 1024
#define obrazok_y 256 // 1024
#define obrazok_textura_x 256 // 1024
#define obrazok_textura_y 256 // 1024

height_map::height_map()
{
	FILE* sub;
	vyska = new unsigned char[obrazok_x*obrazok_y];
	if(vyska==NULL){MessageBox(NULL,"Chyba","Malo pamete",MB_OK | MB_ICONERROR); keys[VK_ESCAPE]=1;return;}
	sub = fopen("data/height_map.raw","r");
	//sub = fopen("data/Terrain.raw","r");
	if(sub == NULL) {MessageBox(NULL,"Nemozem otvorit data/height_map.raw !","Chyba",MB_OK | MB_ICONERROR); keys[VK_ESCAPE]=1;return;}
	fread( vyska, obrazok_x*obrazok_y, 1, sub );
	fclose(sub);
	
/*	textura = new unsigned char[obrazok_textura_x*obrazok_textura_y];
	if(textura==NULL){MessageBox(NULL,"Chyba","Malo pamete",MB_OK | MB_ICONERROR); keys[VK_ESCAPE]=1;return;}
	sub = fopen("data/textura.raw","r");
	if(sub == NULL) {MessageBox(NULL,"Nemozem otvorit data/textura.raw !","Chyba",MB_OK | MB_ICONERROR); keys[VK_ESCAPE]=1;return;}
	fread( textura, obrazok_textura_x*obrazok_textura_y, 1, sub );
	fclose(sub);
	Vypocitaj_prechody();
*/
}

height_map::~height_map()
{
//	if(textura!=NULL)delete [] textura;
	if(vyska!=NULL)delete [] vyska;
}

float height_map::Fxz(float x, float z)
{
	double i,j,zx,zz;	// zx,zz zvysok
	int x0,x1,y0,y1;
	int x0_,y0_;

	if(vyska == NULL)return 0.0;

	i = (x+box_sirka/2.0)/box_sirka;
	j = (z+box_dlzka/2.0)/box_dlzka;

	i = (obrazok_x-1)*fabs(i);
	j = (obrazok_y-1)*fabs(j);

	x0_ = (int) floor(i);	// vrati mensiu celu cast 2.8 -> 2.0
	y0_ = (int) floor(j);	// -2.8  -> -3.0

	if(x0_ > obrazok_x-1)x0_=0;
	if(y0_ > obrazok_y-1)y0_=0;

	zx = fmod(i,1.0);
	zz = fmod(j,1.0);

	x0 = vyska[y0_*obrazok_y + x0_];
	x1 = vyska[y0_*obrazok_y + x0_ + 1];
	y0 = vyska[(y0_+1)*obrazok_y + x0_];
	y1 = vyska[(y0_+1)*obrazok_y + x0_ + 1];

	i = zx*(float)(x1-x0) + (float)x0; 
	j =	zx*(float)(y1-y0) + (float)y0;
	i = zz*(j-i)+i;
	return (float)i*0.1f;
}

/*
unsigned int height_map::Textura(int x, int y)
{
	unsigned int temp;
	if( x >=obrazok_textura_x) x %= obrazok_textura_x;
	if( y >=obrazok_textura_y) y %= obrazok_textura_y;

	
	temp = textura[y*obrazok_textura_x+x];
//	if(temp >= POCET_TEXTUR)temp %= POCET_TEXTUR;
//	if(temp==0)temp=1;
	return temp;
}
*/
/*
unsigned int height_map::Textura(int x, int y)
{
	unsigned int temp,r,g,b;
	if( x >=obrazok_textura_x) x %= obrazok_textura_x;
	if( y >=obrazok_textura_y) y %= obrazok_textura_y;

	r = textura[3*(y*obrazok_textura_x+x)];
	g = textura[3*(y*obrazok_textura_x+x)+1];
	b = textura[3*(y*obrazok_textura_x+x)+2];

	temp = 0;
	if(g => 100) temp = 2;		// trava
	if(g < 100) temp = 1;		// piesok
	return temp;
}*/

unsigned int height_map::Textura(int x, int y)
{
	unsigned int temp,vyska_;
	if( x >=obrazok_x) x %= obrazok_x;
	if( y >=obrazok_y) y %= obrazok_y;

	vyska_ = vyska[y*obrazok_x+x];

	temp = 0;
	if(vyska_ > 200) temp = 4;
	else if(vyska_ > 150) temp = 3;	// hneda
	else if(vyska_ > 100) temp = 1;	// piesok
	else temp = 2;				// trava
	return temp;
}

void height_map::Vypocitaj_prechody()
{
	unsigned int a,b;
	a = 0;
	b = 7;
	
	for(unsigned int j=0; j<obrazok_textura_y;j++)
	{
		for(unsigned int i=0; i<obrazok_textura_x-1;i++)
		{
			if     (textura[j*obrazok_textura_x+i]==a+_0 && textura[j*obrazok_textura_x+i+1]==a+_1)textura[j*obrazok_textura_x+i+1]=a+_01;
			else if(textura[j*obrazok_textura_x+i]==a+_1 && textura[j*obrazok_textura_x+i+1]==a+_0)textura[j*obrazok_textura_x+i+1]=a+_10;
			else if(textura[j*obrazok_textura_x+i]==a+_01 && textura[j*obrazok_textura_x+i+1]==a+_0)textura[j*obrazok_textura_x+i+1]=a+_10;
			else if(textura[j*obrazok_textura_x+i]==a+_10 && textura[j*obrazok_textura_x+i+1]==a+_1)textura[j*obrazok_textura_x+i+1]=a+_01;
		}
	}
}
